/*
 *  Intro Splash -- WiFiBoy32 Demo Code for Arduino/ESP32
 *
 *  July 18, 2017 Created. (derek@wifiboy.org)
 *
 */
#include <wifiboy32.h>
#include <math.h>
#include "wb32-demo2.h"

uint8_t m_x[50], m_v[50], m_c[50];
uint16_t m_y[50];

float x1, x1d, x2, x2d, x3, x3d, x4, x4d, x5, x5d, yt, ytd, xt, xtd;
float sca, sd, ang, ad;

uint8_t wb32_buf8[76800]; 

void setup() {
  
  wb32_init();
  wb32_fillScreen(wbBLACK);
  
  for(int i=0; i<50; i++) {
    m_x[i]=random(0,240); m_y[i]=random(0,320);
    m_v[i]=random(10,25); m_c[i]=random(0,256);
  }
  
  pinMode(17,INPUT); pinMode(32,INPUT); pinMode(34,INPUT); pinMode(35,INPUT);
  
  for(int i=0; i<256; i++) 
    wb32_setPal8(i, wb32_color565(sprite_pal[i][0],sprite_pal[i][1],sprite_pal[i][2]));

  sca=0.3; sd=0.05; ang=0.0; ad=0.1;
  x1d = 0.5; x2d = 0.4; x3d = 0.4; x4d = 0.3; x5d = 0.3;
  x1 = 36; x2 = 41; x3 = 52; x4 = 52; x5 = 55;
  yt = 100; ytd = 2; xt = 120; xtd = 2;
}

void loop() {

  // getkey
  if (digitalRead(17)==0) { if (ad>0 && ad>0.05) ad-=0.02; if (ad<0 && ad <-0.05) ad+=0.02; }
  if (digitalRead(32)==0) { if (ad>0 && ad<0.8) ad+=0.02; if (ad<0 && ad>-0.5) ad-=0.02; }

  wb32_clearBuf8();

  // stars
  for(int i=0; i<50; i++) {
    wb32_setBuf8(m_x[i]+m_y[i]*240, m_c[i]);
    m_y[i] += m_v[i];
    if (m_y[i]>=320) m_y[i]-=320;
  }

  wb32_rot8(xt, yt, ang, sca, 43,37, 152,93, (uint8_t *)sprites);
  yt = yt+ytd; if (yt<50 || yt>260) { ytd=-ytd; ad=-ad; }
  xt = xt+xtd; if (xt<50 || xt>180) { xtd=-xtd; } //ad=-ad; }
    
  ang+=ad;
  sca+=sd; if (sca>=0.7 || sca <=0.1) sd=-sd;
    
  wb32_blitBuf8(70, 132, 240, 70, 60, 100, 28, (uint8_t *)sprites);
  wb32_blitBuf8(63, 293, 240, 65, 300, 110, 14, (uint8_t *)sprites);
  wb32_blitBuf8(34, 166, 240, x1, 100, 172, 11, (uint8_t *)sprites);
  x1 = x1+x1d; if (x1<32 || x1>36) x1d = -x1d;
  wb32_blitBuf8(43, 196, 240, x2, 170, 154, 11, (uint8_t *)sprites);
  x2 = x2+x2d; if (x2<41 || x2>45) x2d = -x2d;
  wb32_blitBuf8(49, 216, 240, x3, 190, 141, 13, (uint8_t *)sprites);
  x3 = x3+x3d; if (x3<48 || x3>52) x3d = -x3d;
  wb32_blitBuf8(54, 237, 240, x4, 210, 133, 13, (uint8_t *)sprites);
  x4 = x4+x4d; if (x4<52 || x4>56) x4d = -x4d;
  wb32_blitBuf8(54, 258, 240, x5, 230, 134, 11, (uint8_t *)sprites);
  x5 = x5+x5d; if (x5<51 || x5>55) x5d = -x5d;
 
  wb32_blit8(); // blit to LCD
}
